
/**
 * @package     embedanonform.min.js 1.2
 * @copyright   (C) 2024 Anonform Ab. <https://anonform.com>
 * @license     GNU General Public License version 2 or later
 *
 * WordPress style shortcode vanilla JavaScript replacer to embed
 * ANON::form forms i website page as a responsive iframe
 *
 * [anonform link="path to the form"]
 *
 * default css "margin:0;padding:0;border:none;max-width:750px", can
 * be replaced (must be replaced by a full css replacement string) by
 * the "css" option in shortcode
 *
 * [anonform link="path to the form" css="full css string"]
 *
 */
var embedanonform=function(t,n){t&&(this.el=t,this.tags=n,this.matches=[],this.regex="\\[{name}(\\s[\\s\\S]*?)?\\](?:((?!\\s*?(?:\\[{name}|\\[\\/(?!{name})))[\\s\\S]*?)(\\[/{name}\\]))?",this.matchTags(),this.convertMatchesToNodes(),this.replaceNodes())};embedanonform.prototype.matchTags=function(){var t,n,a,r,s,o,i,c=this.el.outerHTML;for(var p in this.tags){if(!this.tags.hasOwnProperty(p))return;a=this.template(this.regex,{name:p}),t=c.match(RegExp(a,"g"))||[];for(var h=0,m=t.length;h<m;h++)r=(n=t[h].match(RegExp(a)))[3]?"":void 0,o=n[0],s=this.escapeTagRegExp(o),i=this.parseOptions(n[1]),n[2]&&(r=n[2].trim(),o=o.replace(r,"").replace(/\n\s*/g,""),s=this.escapeTagRegExp(o).replace("\\]\\[","\\]([\\s\\S]*?)\\[")),this.matches.push({name:p,tag:o,regex:s,options:i,contents:r})}},embedanonform.prototype.convertMatchesToNodes=function(){var t,n,a,r=this.el.innerHTML;a=function(t,n,a,r,s,o,i){if(n)return t;var c=document.createElement("span");return c.setAttribute("data-sc-tag",this.tag),c.className="sc-node sc-node-"+this.name,c.outerHTML};for(var s=0,o=this.matches.length;s<o;s++)n=RegExp((t='((data-sc-tag=")|(<pre.*)|(<code.*))?')+this.matches[s].regex,"g"),r=r.replace(n,a.bind(this.matches[s]));this.el.innerHTML=r},embedanonform.prototype.replaceNodes=function(){var t,n,a,r,s,o,i=this;this.el.querySelectorAll(".sc-node"),o=function(t){t=i.parseCallbackResult(t),r.parentNode.replaceChild(t,r)};for(var c=0,p=this.matches.length;c<p;c++)t=this.matches[c],(r=this.el.querySelector(".sc-node-"+t.name))&&r.dataset.scTag===t.tag&&void 0!==(n=(s=this.tags[t.name].bind(t))(a=o.bind(t)))&&a(n)},embedanonform.prototype.parseCallbackResult=function(t){var n,a,r;switch(typeof t){case"function":t=document.createTextNode(t());break;case"string":if(n=document.createElement("div"),a=document.createDocumentFragment(),n.innerHTML=t,(r=n.childNodes).length){for(var s=0,o=r.length;s<o;s++)a.appendChild(r[s].cloneNode(!0));t=a}else t=document.createTextNode(t);break;case"object":t.nodeType||(t=JSON.stringify(t),t=document.createTextNode(t))}return t},embedanonform.prototype.parseOptions=function(t){var n,a={};if(t){(n=t.replace(/(\w+=)/g,"\n$1").split("\n")).shift();for(var r=0;r<n.length;r++){var s=n[r].split("=");a[s[0]]=s[1].replace(/\'|\"/g,"").trim()}return a}},embedanonform.prototype.escapeTagRegExp=function(t){return t.replace(/[\[\]\/]/g,"\\$&")},embedanonform.prototype.template=function(t,n){for(var a in n)t=t.replace(RegExp("{"+a+"}","g"),n[a]);return t},String.prototype.trim=String.prototype.trim||function(){return this.replace(/^\s+|\s+$/g,"")},document.addEventListener("DOMContentLoaded",()=>{new embedanonform(document.querySelector("body"),{anonform:function(){if(this.options.css)var t=this.options.css;else var t="margin:0;padding:0;border:none;width:100%;max-width:750px";return'<iframe id="anonform-app" src="'+this.options.link+'" loading="lazy" style="'+t+'" title="Embedded ANON::form"></iframe>'}}),function(){let t=Array.from(document.querySelectorAll("iframe")),n=window.addEventListener?"addEventListener":"attachEvent",a=window[n];a("attachEvent"===n?"onmessage":"message",n=>{let a=t.find(t=>t.contentWindow===n.source);if(null==a)return;let r=n.message?"message":"data",s=n[r];document.getElementById(a.id).style.height=s+"px"},!1),window.onresize=function(){e.contentWindow.postMessage("parentWindowResized","*")}}()});